__author__ = 'Martin'

def factorial(n):
    if n > 1:
        return n *  factorial(n - 1) # recursive case
    else:
        return 1    # base case


from stack import stack as Stack

def stk_factorial(n):
    stk = Stack(n-1)
    while n > 1:
        stk.push(n)
        n -= 1

    result = 1
    while not stk.is_empty():
        n = stk.pop()
        result *= n     # multiply result by n, actually result = result * n
    return result

def tr_factorial(n, result=1):
    if n > 1:
        return tr_factorial(n - 1, n * result)
    else:
        return result

def lp_factorial(n):
    result = 1
    while n > 1:
        result = n * result
        n = n - 1
    return result

def nPm(n, m):
    """
    The number of sequences of m items from n items where order is significant
    """
    if m > n: return 0
    r = 1
    for x in range(n - m + 1, n+1):
        r *= x
    return r

def nCm(n, m):
    """
    The number of sets of m items from n items where order is not significant
    """
    return nPm(n, m) // factorial(m)    # divide by the number of ways of arranging m items


if __name__ == '__main__':

    print(factorial(5))

    print(stk_factorial(5))

    print(tr_factorial(5))

    print(lp_factorial(5))

    print(nPm(42, 3))

    print(nCm(49,6))
