__author__ = 'Martin'

from array_types import array_


class stack:
    def __init__(self, max_size):
        self.array = array_(max_size)
        self.SP = 0     # the stack pointer
        self.max_size = max_size

    def size(self):
        return self.SP

    def is_empty(self):
        return not self.SP

    def is_full(this):
        return this.SP == this.max_size

    def top(self):
        return self.array[self.SP-1]

    def push(self, item):
        assert self.size() < self.max_size, 'stack overflow'
        self.array[self.SP] = item
        self.SP += 1

    def pop(self):
        assert self.size() > 0, 'stack underflow'
        self.SP -= 1
        return self.array[self.SP]

    def maxsize(self):
        return self.maxsize()



if __name__ == '__main__':

    a_stack = stack(6)
    push_stack = a_stack.push   # push is a field of a_stack
                                # the bound method was assigned to push_stack
    push_stack('||')            # pushes this item onto a_stack
    print('stack size:', a_stack.size(), '  stack array:', a_stack.array)

    a_stack.push('item')        # general
    print('stack size:', a_stack.size(), '  stack array:', a_stack.array)
    p = a_stack.pop()

    stack.push(a_stack, '22')   # gets a free method from the class and calls it
    print('stack size:', a_stack.size(), '  stack array:', a_stack.array)

